###############################################################################
#
# Copyright (c) 2004 TINY SPRL. (http://tiny.be) All Rights Reserved.
#                    Fabien Pinckaers <fp@tiny.Be>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import time
import pooler
import openobject.xmlrpc as rpc
import wizard
from osv import osv, fields, orm
from osv.osv import except_osv
from tools.translate import _

class account_analytic_account(osv.osv):
	_inherit = 'account.analytic.account'
	_columns = {
                'nbrused': fields.integer('nbrused'),
        }
account_analytic_account()

class hr_analytic_timesheet(osv.osv):
    _inherit = "hr.analytic.timesheet"

    def create(self, cr, uid, vals, context=None):
        if context is None:
            context = {}
        emp_obj = self.pool.get('hr.employee')
        emp_id = emp_obj.search(cr, uid, [('user_id', '=', context.get('user_id', uid))], context=context)
        ename = ''
	journal = self.pool.get('hr.employee').browse(cr, uid, emp_id[0]).journal_id
 	val = {'account_id':vals['account_id'],'unit_amount':vals['unit_amount'],'product_uom_id':vals['product_uom_id'],'name':vals['name'],'product_id':vals['product_id'],'journal_id':journal.id }
	if emp_id:
            ename = emp_obj.browse(cr, uid, emp_id[0], context=context).name
        if not val.get('journal_id',False):
           raise osv.except_osv(_('Warning !'), _('Analytic journal is not defined for employee %s \nDefine an employee for the selected user and assign an analytic journal!')%(ename,))
        if not vals.get('account_id',False):
           raise osv.except_osv(_('Warning !'), _('No analytic account defined on the project.\nPlease set one or we can not automatically fill the timesheet.'))
        return super(hr_analytic_timesheet, self).create(cr, uid, val, context=context)

hr_analytic_timesheet()

class hr_employee(osv.osv):
    _inherit = "hr.employee"
    _description = "Employee"

    def _action_check(self, cr, uid, emp_id, dt=False, context=None):
        cr.execute('SELECT MAX(name) FROM hr_attendance WHERE employee_id=%s', (emp_id,))
        res = cr.fetchone()
	timestring = dt
	if type(timestring) == str:
		time_format = "%Y-%m-%d %H:%M:%S"
		mytime = time.strptime(timestring,time_format)
		year = str(mytime[0])
		month = str(mytime[1])
		day = str(mytime[2])
		hour = str(mytime[3])
		minute = str(mytime[4])
		second = str(mytime[5])
		if mytime[1] < 10:
	   	    month = "0"+month
		if mytime[2] < 10:
	  	    day = "0"+day
		if mytime[3] < 10:
	    	    hour = "0"+hour
		if mytime[4] < 10:
	    	    minute = "0"+minute
		if mytime[5] < 10:
		    second = "0"+second
		thistime = year+"-"+month+"-"+day+" "+hour+":"+minute+":"+second
		print(res[0],thistime)
        	return not (res and (res[0]>=(thistime or time.strftime('%Y-%m-%d %H:%M:%S'))))
	else:
		return not (res and (res[0]>=(dt or time.strftime('%Y-%m-%d %H:%M:%S'))))
hr_employee() 

class j2me_signio(osv.osv):
    _name = "j2me.signio"  
    
    def _write(self, cr, uid, data, emp_id):
        timesheet_obj = pooler.get_pool(cr.dbname).get('hr.analytic.timesheet')
        hour = (time.mktime(time.strptime(data['form']['date'] or time.strftime('%Y-%m-%d %H:%M:%S'), '%Y-%m-%d %H:%M:%S')) -
        time.mktime(time.strptime(data['form']['date_start'], '%Y-%m-%d %H:%M:%S'))) / 3600.0
        minimum = data['form']['analytic_amount']
        if minimum:
            hour = round(round((hour + minimum / 2) / minimum) * minimum, 2)
        res = timesheet_obj.default_get(cr, uid, ['product_id','product_uom_id'])
        if not res['product_uom_id']:
            raise wizard.except_wizard(_('UserError'), _('No cost unit defined for this employee !'))
        up = timesheet_obj.on_change_unit_amount(cr, uid, False, res['product_id'], hour, res['product_uom_id'])['value']
        res['name'] = data['form']['info']
        res['account_id'] = data['form']['account_id']
        res['unit_amount'] = hour
        res.update(up)
        up = timesheet_obj.on_change_account_id(cr, uid, [], res['account_id']).get('value', {})
        res.update(up)		
        return timesheet_obj.create(cr, uid, res)

    def _get_empid(self, cr, uid):
        emp_obj = pooler.get_pool(cr.dbname).get('hr.employee')
        user_ids = emp_obj.search(cr, uid, [('user_id','=',uid)])
        if not len(user_ids):
            raise wizard.except_wizard(_('Error !'), _('No employee defined for your user !'))
        emp_id = emp_obj.search(cr, uid, [('user_id', '=', uid)])
        if emp_id:
            employee = emp_obj.read(cr, uid, emp_id)[0]
            return {'name': employee['name'], 'state': employee['state'], 'emp_id': emp_id[0], 'date':False, 'server_date':time.strftime('%Y-%m-%d %H:%M:%S')}
        raise wizard.except_wizard(_('UserError'), _('No employee defined for your user !'))
		
    def sign_in(self, cr, uid, date=False):
	emp_obj = pooler.get_pool(cr.dbname).get('hr.employee')
	data = self._get_empid(cr,uid)
	emp_id = data['emp_id']
	context = {'lang':False}	      
	
	try:
		emp_obj.attendance_action_change(cr, uid, [emp_id], 'sign_in', dt=date or False)
	#	success = emp_obj.sign(cr, uid, [emp_id],context, dt=date or False)
	except except_osv, e:
		raise wizard.except_wizard(e.name, e.value)
	return {}
    
    def sign_out(self, cr, uid, info, code, date=False):
        emp_data = self._get_empid(cr,uid)
	
	#recuperation heure sign in	
	cr.execute("SELECT MAX(name) FROM hr_attendance WHERE action = 'sign_in' AND create_uid = %s" % uid)
	signin = cr.fetchone()
	signinvalue = signin[0]
		
        account_obj = pooler.get_pool(cr.dbname).get('account.analytic.account')
        account_id = account_obj.search(cr, uid, [('code', '=', code)])[0]
	data = {'form': {'account_id': account_id, 'date': date,'analytic_amount':False,'date_start': signinvalue,'emp_id':emp_data['emp_id'],
                        'info': info, 'server_date': emp_data['server_date'],'state': emp_data['state']},'id': 351, 'ids': [351]}
	emp_obj = pooler.get_pool(cr.dbname).get('hr.employee')
	emp_obj.attendance_action_change(cr, uid, [emp_data['emp_id']], 'sign_out', dt=data['form']['date'])
        #emp_obj.sign_out(cr, uid, [emp_data['emp_id']], dt=data['form']['date'])
        self._write(cr, uid, data, emp_data['emp_id'])		
	account = account_obj.read(cr, uid,account_id)
        if (account['nbrused'] == False):
            account['nbrused'] = 0
        account_obj.write(cr,uid,account_id,{'nbrused': account['nbrused']+1})		
        self.get_favorite_accounts(cr,uid,3)
        return {}

    def get_state(self, cr, uid):
        emp_id = self._get_empid(cr, uid)['emp_id']
        cr.execute('select action from hr_attendance where employee_id=%s and action in (\'sign_in\',\'sign_out\') order by name desc limit 1', (emp_id,))
        res = (cr.fetchone() or ('sign_out',))[0]
        return res
       
       ids = self.search(cr, uid, [('employee_id', '=', )])
       

    def get_favorite_accounts(self, cr, uid, limit):
        cr.execute('select name, code from account_analytic_account where nbrused is not NULL order by nbrused limit %s', (limit,))
        return cr.fetchall()
    
    def get_all_accounts(self, cr, uid):
        cr.execute('select name, code from account_analytic_account order by name')
        return cr.fetchall()
       
       accounts = []
       ids = self.search(cr, uid, True)
       for account in self.browse(cr, uid, ids):
       accounts.append(account.code,account.name)
       return accounts
	
j2me_signio()